function love.load()
    tileString = ""
    player = {}
    player.x = 0
    player.y = 0
    player.row = 0
    player.col = 0
    player.r = 10
    exit = {}
    exit.x = 0
    exit.y = 0
    exit.w = 20
    exit.h = 20
    tmpStr = ""
    level = 1
    levelcount = 0
    rowcount = 0
    colcount = 0
    finished = false
    start = true
    moves = 0
    font = love.graphics.newFont(48)
    font2 = love.graphics.newFont(24)
    title = love.graphics.newText(font, "Flipper")
    msg = love.graphics.newText(font2, "Reach the exit.\nW, S to flip vertically,\nA, D to flip horizontally.\nPress Space to start.")
    endmsg = love.graphics.newText(font2, "Yay! You finished this little game.")
	files = love.filesystem.getDirectoryItems("maps")
  	for _,everylevel in ipairs(files) do
      	levelcount = levelcount + 1
  	end
  	maps = {}
  	for _,m in ipairs(files) do table.insert(maps, "maps/"..m) end
  	table.sort(maps)
  	loadMap(maps[level])    
end

function love.update(dt)

end

function love.draw()
    if not start then
        if not finished then
        	drawMap()
            love.graphics.setColor(255, 0 ,0)
            love.graphics.circle("fill", player.x + 10, player.y + 10, player.r)
            love.graphics.setColor(0, 255, 0)
            love.graphics.rectangle("fill", exit.x, exit.y, exit.w, exit.h)
            love.graphics.setColor(255,255,255)
            movestext = love.graphics.newText(font, tostring(moves))
            love.graphics.draw(movestext, 700, 60)
        else
            love.graphics.setColor(255, 255, 255)
            love.graphics.draw(endmsg, 400 - endmsg:getWidth() / 2, 300 - endmsg:getHeight() / 2)
            movestext = love.graphics.newText(font, "You made "..tostring(moves).." moves")
            love.graphics.draw(movestext, 400 - movestext:getWidth() / 2, 360)
        end
    else
        love.graphics.setColor(255,255,0)
        love.graphics.draw(title, 400 - title:getWidth() / 2, 300 - title:getHeight() / 2)
        love.graphics.setColor(0,0,255)
        love.graphics.draw(msg, 400 - msg:getWidth() / 2, 340)
    end
end

function love.keypressed(key)
    if key == "escape" and start then
        love.event.quit()
    end
    if key == "escape" and not start then
        start = true
        moves = 0
        level = 1
    end
    if key == "space" and start then
        start = false
    end
    if key == "d" then
        if tileTable[colcount - player.col][player.row] == " " or tileTable[colcount - player.col][player.row] == "P" or  tileTable[colcount - player.col][player.row] == "X" then
            tmpStr = ""
            for row in tileString:gmatch("[^\n]+") do
                row = row:reverse()
                tmpStr = tmpStr..row.."\n"
  	        end
            tmpStr = tmpStr:gsub("P", " ")
            tileString = tmpStr
            newMap(tileString)
            moves = moves + 1
        end
    end
    if key == "a" then
        if tileTable[colcount - player.col][player.row] == " " or tileTable[colcount - player.col][player.row] == "P" or  tileTable[colcount - player.col][player.row] == "X" then
            tmpStr = ""
            for row in tileString:gmatch("[^\n]+") do
                row = row:reverse()
                tmpStr = tmpStr..row.."\n"
  	        end
            tmpStr = tmpStr:gsub("P", " ")
            tileString = tmpStr
            newMap(tileString)
            moves = moves + 1
        end
    end
    if key == "w" then
        if tileTable[player.col][rowcount - player.row] == " " or tileTable[player.col][rowcount - player.row] == "P" or  tileTable[player.col][rowcount - player.row] == "X" then
            tmpStr = ""
            local tmpTable = {}
            rowc = 0
            for row in tileString:gmatch("[^\n]+") do
                rowc = rowc + 1
                tmpTable[rowc] = row
  	        end
            for i=1,#tmpTable,1 do
                tmpStr = tmpStr..tmpTable[#tmpTable + 1 - i].."\n"
            end
            tmpStr = tmpStr:gsub("P", " ")
            tileString = tmpStr
            newMap(tileString)
            moves = moves + 1
        end
    end
    if key == "s" then
        if tileTable[player.col][rowcount - player.row] == " " or tileTable[player.col][rowcount - player.row] == "P" or  tileTable[player.col][rowcount - player.row] == "X" then
            tmpStr = ""
            local tmpTable = {}
            rowc = 0
            for row in tileString:gmatch("[^\n]+") do
                rowc = rowc + 1
                tmpTable[rowc] = row
  	        end
            for i=1,#tmpTable,1 do
                tmpStr = tmpStr..tmpTable[#tmpTable + 1 - i].."\n"
            end
            tmpStr = tmpStr:gsub("P", " ")
            tileString = tmpStr
            newMap(tileString)
            moves = moves + 1
        end
    end
    if key == "right" then
        player.x = player.x + 20
        player.col = player.col + 1
        moves = moves + 1
        if tileTable[player.col][player.row] == "X" then
            level = level + 1
            if level > levelcount then
                finished = true
            else
                loadMap(maps[level])
            end
        end
        for _,tile in ipairs(tilecorners) do
            local row,col = tile[3],tile[4]
            if player.row == row and player.col == col then
                if tileTable[col][row] == "#" then
                    player.x  = player.x - 20
                    player.col = player.col - 1
                    moves = moves - 1
                end
             end
        end
    end
    if key == "left" then
        player.x = player.x - 20
        player.col = player.col - 1
        moves = moves + 1
        if tileTable[player.col][player.row] == "X" then
            level = level + 1
            if level > levelcount then
                finished = true
            else
                loadMap(maps[level])
            end
        end
        for _,tile in ipairs(tilecorners) do
            local row,col = tile[3],tile[4]
            if player.row == row and player.col == col then
                if tileTable[col][row] == "#" then
                    player.x  = player.x + 20
                    player.col = player.col + 1
                    moves = moves - 1
                end
             end
         end
    end
    if key == "up" then
        player.y = player.y - 20
        player.row = player.row - 1
        moves = moves + 1
        if tileTable[player.col][player.row] == "X" then
            level = level + 1
            if level > levelcount then
                finished = true
            else
                loadMap(maps[level])
            end
        end
        for _,tile in ipairs(tilecorners) do
            local row,col = tile[3],tile[4]
            if player.row == row and player.col == col then
                if tileTable[col][row] == "#" then
                    player.y  = player.y + 20
                    player.row = player.row + 1
                    moves = moves - 1
                end
             end
         end
    end
    if key == "down" then
        player.y = player.y + 20
        player.row = player.row + 1
        moves = moves + 1
        if tileTable[player.col][player.row] == "X" then
            level = level + 1
            if level > levelcount then
                finished = true
            else
                loadMap(maps[level])
            end
        end
        for _,tile in ipairs(tilecorners) do
            local row,col = tile[3],tile[4]
            if player.row == row and player.col == col then
                if tileTable[col][row] == "#" then
                    player.y  = player.y - 20
                    player.row = player.row - 1
                    moves = moves - 1
                end
             end
         end
    end
end

function loadMap(path)
    tileString = love.filesystem.load(path)()
    newMap(tileString)
end

function newMap(tileStr)
	love.graphics.clear()
	tilecorners = {}
	cb = 0

  	tileTable = {}

  	local width = #(tileStr:match("[^\n]+"))

  	for x = 1,width,1 do tileTable[x] = {} end

  	local rowIndex,columnIndex = 1,1
    rowcount = 1
  	for row in tileStr:gmatch("[^\n]+") do
    	assert(#row == width, 'Map is not aligned: width of row ' .. tostring(rowIndex) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
    	columnIndex = 1
        colcount = 1
    	for character in row:gmatch(".") do
      		tileTable[columnIndex][rowIndex] = character
			if character == "#" then
	  			cb = cb + 1
	  			tilecorners[cb] = { (columnIndex - 1)*20, (rowIndex - 1)*20, rowIndex, columnIndex }
			end
            if character == "P" then
                player.x = (columnIndex - 1) * 20
                player.y = (rowIndex - 1) * 20
                player.row = rowIndex
                player.col = columnIndex
            end
            if character == "X" then
                exit.x = (columnIndex - 1) * 20
                exit.y = (rowIndex - 1) * 20
            end
      	columnIndex = columnIndex + 1
        colcount = colcount + 1
    	end
    	rowIndex=rowIndex+1
        rowcount = rowcount + 1
  	end
end

function drawMap()
  	for _,tiletable in ipairs(tilecorners) do
      	local x,y = tiletable[1], tiletable[2]
		love.graphics.setColor(0,0,255)
      	love.graphics.rectangle("fill", x, y, 20, 20)
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("line", x, y, 20, 20)
  	end
end
